package b4a.helpgp;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.helpgp", "b4a.helpgp.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.helpgp", "b4a.helpgp.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.helpgp.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button2 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button3 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button4 = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edittext1 = null;
public anywheresoftware.b4a.objects.LabelWrapper _label4 = null;
public anywheresoftware.b4a.objects.ListViewWrapper _listview1 = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbl3 = null;
public anywheresoftware.b4a.objects.PanelWrapper _panel1 = null;
public static int _d = 0;
public static int _k = 0;
public static int _noviews = 0;
public static int _ln = 0;
public static int _bv = 0;
public static int _qq = 0;
public static String[] _pictures = null;
public static String _dmn = "";
public static String[] _arcpos = null;
public static int _ll = 0;
public static int _tt = 0;
public static int _ww = 0;
public static int _hh = 0;
public static String _txt = "";
public static String _posobj = "";
public static String _npos = "";
public static int _sx = 0;
public static int _sy = 0;
public static int _tx = 0;
public static String _valore = "";
public static String _coord = "";
public static String _ncoord = "";
public static String[] _t = null;
public static String[] _v = null;
public static String[] _pos = null;
public static String _name = "";
public static String _linea = "";
public static String _linew = "";
public static String _coor = "";
public static int _a = 0;
public static int _b = 0;
public static int _c = 0;
public static int _nx = 0;
public static int _ny = 0;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
int _i = 0;
String _cx = "";
int _s = 0;
 //BA.debugLineNum = 54;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 57;BA.debugLine="Activity.LoadLayout(\"main\")";
mostCurrent._activity.LoadLayout("main",mostCurrent.activityBA);
 //BA.debugLineNum = 58;BA.debugLine="D = Activity.Width/2";
_d = (int) (mostCurrent._activity.getWidth()/(double)2);
 //BA.debugLineNum = 60;BA.debugLine="Pictures(0) = \"Balo0.png\"";
mostCurrent._pictures[(int) (0)] = "Balo0.png";
 //BA.debugLineNum = 61;BA.debugLine="Pictures(1) = \"Balo1.png\"";
mostCurrent._pictures[(int) (1)] = "Balo1.png";
 //BA.debugLineNum = 62;BA.debugLine="Pictures(2) = \"Balo2.png\"";
mostCurrent._pictures[(int) (2)] = "Balo2.png";
 //BA.debugLineNum = 63;BA.debugLine="Pictures(3) = \"Balo3.png\"";
mostCurrent._pictures[(int) (3)] = "Balo3.png";
 //BA.debugLineNum = 65;BA.debugLine="T(0) = \"Select here the actions on Archive\"";
mostCurrent._t[(int) (0)] = "Select here the actions on Archive";
 //BA.debugLineNum = 66;BA.debugLine="T(1) = \"Select here the actions on Record\"";
mostCurrent._t[(int) (1)] = "Select here the actions on Record";
 //BA.debugLineNum = 67;BA.debugLine="T(2) = \"Write here the Archive/Record wished\"";
mostCurrent._t[(int) (2)] = "Write here the Archive/Record wished";
 //BA.debugLineNum = 68;BA.debugLine="T(3) = \"List of contents object of the actions\"";
mostCurrent._t[(int) (3)] = "List of contents object of the actions";
 //BA.debugLineNum = 69;BA.debugLine="T(4) = \"Click to lock-Long Click to close\"";
mostCurrent._t[(int) (4)] = "Click to lock-Long Click to close";
 //BA.debugLineNum = 70;BA.debugLine="T(5) = \"List of the actions preselected\"";
mostCurrent._t[(int) (5)] = "List of the actions preselected";
 //BA.debugLineNum = 71;BA.debugLine="T(6) = \"Reset actions data or the ended actions\"";
mostCurrent._t[(int) (6)] = "Reset actions data or the ended actions";
 //BA.debugLineNum = 73;BA.debugLine="qq = Activity.NumberOfViews : BV = qq";
_qq = mostCurrent._activity.getNumberOfViews();
 //BA.debugLineNum = 73;BA.debugLine="qq = Activity.NumberOfViews : BV = qq";
_bv = _qq;
 //BA.debugLineNum = 75;BA.debugLine="NoViews = 6";
_noviews = (int) (6);
 //BA.debugLineNum = 77;BA.debugLine="k = -1";
_k = (int) (-1);
 //BA.debugLineNum = 78;BA.debugLine="For i = 0 To NoViews : k = k+1";
{
final int step46 = 1;
final int limit46 = _noviews;
for (_i = (int) (0); (step46 > 0 && _i <= limit46) || (step46 < 0 && _i >= limit46); _i = ((int)(0 + _i + step46))) {
 //BA.debugLineNum = 78;BA.debugLine="For i = 0 To NoViews : k = k+1";
_k = (int) (_k+1);
 //BA.debugLineNum = 79;BA.debugLine="V(i) = Activity.GetView(i)";
mostCurrent._v[_i] = BA.ObjectToString(mostCurrent._activity.GetView(_i));
 //BA.debugLineNum = 80;BA.debugLine="Linea = V(i)";
mostCurrent._linea = mostCurrent._v[_i];
 //BA.debugLineNum = 81;BA.debugLine="Tx = (Linea).IndexOf(\":\")";
_tx = (mostCurrent._linea).indexOf(":");
 //BA.debugLineNum = 82;BA.debugLine="Name = Linea.SubString2(0, Tx)";
mostCurrent._name = mostCurrent._linea.substring((int) (0),_tx);
 //BA.debugLineNum = 83;BA.debugLine="Linew = Linea.SubString2(Tx+1, Linea.Length)";
mostCurrent._linew = mostCurrent._linea.substring((int) (_tx+1),mostCurrent._linea.length());
 //BA.debugLineNum = 84;BA.debugLine="Linea = Linew";
mostCurrent._linea = mostCurrent._linew;
 //BA.debugLineNum = 85;BA.debugLine="Cx = Linea.IndexOf(\":\")";
_cx = BA.NumberToString(mostCurrent._linea.indexOf(":"));
 //BA.debugLineNum = 86;BA.debugLine="Coor = Linea.SubString2(Cx+1, Linea.Length)";
mostCurrent._coor = mostCurrent._linea.substring((int) ((double)(Double.parseDouble(_cx))+1),mostCurrent._linea.length());
 //BA.debugLineNum = 87;BA.debugLine="Pos(k) = Pos(k) & Coor & \",\"";
mostCurrent._pos[_k] = mostCurrent._pos[_k]+mostCurrent._coor+",";
 //BA.debugLineNum = 88;BA.debugLine="Linew = Linea.SubString2(Cx+1, Linea.Length)";
mostCurrent._linew = mostCurrent._linea.substring((int) ((double)(Double.parseDouble(_cx))+1),mostCurrent._linea.length());
 //BA.debugLineNum = 89;BA.debugLine="Linea = Linew";
mostCurrent._linea = mostCurrent._linew;
 }
};
 //BA.debugLineNum = 92;BA.debugLine="For s = 0 To NoViews";
{
final int step60 = 1;
final int limit60 = _noviews;
for (_s = (int) (0); (step60 > 0 && _s <= limit60) || (step60 < 0 && _s >= limit60); _s = ((int)(0 + _s + step60))) {
 //BA.debugLineNum = 93;BA.debugLine="Coord = Pos(s)";
mostCurrent._coord = mostCurrent._pos[_s];
 //BA.debugLineNum = 94;BA.debugLine="Do Until Coord.Length = 0";
while (!(mostCurrent._coord.length()==0)) {
 //BA.debugLineNum = 95;BA.debugLine="Tx = Coord.IndexOf(\",\")";
_tx = mostCurrent._coord.indexOf(",");
 //BA.debugLineNum = 96;BA.debugLine="Valore = Coord.Substring2(0,Tx)";
mostCurrent._valore = mostCurrent._coord.substring((int) (0),_tx);
 //BA.debugLineNum = 97;BA.debugLine="If Valore.Contains(\"Left=\") = True Then A = Valore.Replace(\"Left=\", \" \")";
if (mostCurrent._valore.contains("Left=")==anywheresoftware.b4a.keywords.Common.True) { 
_a = (int)(Double.parseDouble(mostCurrent._valore.replace("Left="," ")));};
 //BA.debugLineNum = 98;BA.debugLine="If Valore.Contains(\"Top=\") = True Then B = Valore.Replace(\"Top=\", \" \")";
if (mostCurrent._valore.contains("Top=")==anywheresoftware.b4a.keywords.Common.True) { 
_b = (int)(Double.parseDouble(mostCurrent._valore.replace("Top="," ")));};
 //BA.debugLineNum = 99;BA.debugLine="If Valore.Contains(\"Width=\") = True Then C =Valore.Replace(\"Width=\", \" \")";
if (mostCurrent._valore.contains("Width=")==anywheresoftware.b4a.keywords.Common.True) { 
_c = (int)(Double.parseDouble(mostCurrent._valore.replace("Width="," ")));};
 //BA.debugLineNum = 100;BA.debugLine="If Valore.Contains(\"Height=\") = True Then D = Valore.Replace(\"Height=\", \" \")";
if (mostCurrent._valore.contains("Height=")==anywheresoftware.b4a.keywords.Common.True) { 
_d = (int)(Double.parseDouble(mostCurrent._valore.replace("Height="," ")));};
 //BA.debugLineNum = 101;BA.debugLine="Ncoord = Coord.SubString2(Tx+1, Coord.Length)";
mostCurrent._ncoord = mostCurrent._coord.substring((int) (_tx+1),mostCurrent._coord.length());
 //BA.debugLineNum = 102;BA.debugLine="Coord = Ncoord";
mostCurrent._coord = mostCurrent._ncoord;
 }
;
 //BA.debugLineNum = 104;BA.debugLine="ArcPos(s) = A & \",\" & B & \",\" & C & \",\" & D & \",\" & T(s)";
mostCurrent._arcpos[_s] = BA.NumberToString(_a)+","+BA.NumberToString(_b)+","+BA.NumberToString(_c)+","+BA.NumberToString(_d)+","+mostCurrent._t[_s];
 }
};
 //BA.debugLineNum = 106;BA.debugLine="qq = Activity.NumberOfViews : BV = qq";
_qq = mostCurrent._activity.getNumberOfViews();
 //BA.debugLineNum = 106;BA.debugLine="qq = Activity.NumberOfViews : BV = qq";
_bv = _qq;
 //BA.debugLineNum = 107;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 113;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 115;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 109;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 111;BA.debugLine="End Sub";
return "";
}
public static String  _clearlist() throws Exception{
int _m = 0;
 //BA.debugLineNum = 174;BA.debugLine="Sub ClearList";
 //BA.debugLineNum = 175;BA.debugLine="qq = Activity.NumberOfViews";
_qq = mostCurrent._activity.getNumberOfViews();
 //BA.debugLineNum = 176;BA.debugLine="For m = LN To BV Step -1";
{
final int step135 = (int) (-1);
final int limit135 = _bv;
for (_m = _ln; (step135 > 0 && _m <= limit135) || (step135 < 0 && _m >= limit135); _m = ((int)(0 + _m + step135))) {
 //BA.debugLineNum = 177;BA.debugLine="Activity.RemoveViewAt(m)";
mostCurrent._activity.RemoveViewAt(_m);
 }
};
 //BA.debugLineNum = 179;BA.debugLine="TXT = \"\" : K = 0 : LL = 0 : TT = 0";
mostCurrent._txt = "";
 //BA.debugLineNum = 179;BA.debugLine="TXT = \"\" : K = 0 : LL = 0 : TT = 0";
_k = (int) (0);
 //BA.debugLineNum = 179;BA.debugLine="TXT = \"\" : K = 0 : LL = 0 : TT = 0";
_ll = (int) (0);
 //BA.debugLineNum = 179;BA.debugLine="TXT = \"\" : K = 0 : LL = 0 : TT = 0";
_tt = (int) (0);
 //BA.debugLineNum = 180;BA.debugLine="End Sub";
return "";
}
public static String  _creabal() throws Exception{
anywheresoftware.b4a.objects.ImageViewWrapper _iv = null;
anywheresoftware.b4a.objects.LabelWrapper _lb = null;
 //BA.debugLineNum = 118;BA.debugLine="Sub CreaBal";
 //BA.debugLineNum = 119;BA.debugLine="Dim IV As ImageView";
_iv = new anywheresoftware.b4a.objects.ImageViewWrapper();
 //BA.debugLineNum = 120;BA.debugLine="IV.Initialize(\"ImageView\")";
_iv.Initialize(mostCurrent.activityBA,"ImageView");
 //BA.debugLineNum = 121;BA.debugLine="IV.BringToFront";
_iv.BringToFront();
 //BA.debugLineNum = 122;BA.debugLine="IV.Gravity=Gravity.Fill";
_iv.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.FILL);
 //BA.debugLineNum = 123;BA.debugLine="IV.Visible = True";
_iv.setVisible(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 124;BA.debugLine="IV.Bitmap = LoadBitmap(File.DirAssets,Pictures(K))";
_iv.setBitmap((android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),mostCurrent._pictures[_k]).getObject()));
 //BA.debugLineNum = 125;BA.debugLine="If K = 0 Then Activity.AddView(IV, LL, TT, Lbl3.Width, Lbl3.Width)";
if (_k==0) { 
mostCurrent._activity.AddView((android.view.View)(_iv.getObject()),_ll,_tt,mostCurrent._lbl3.getWidth(),mostCurrent._lbl3.getWidth());};
 //BA.debugLineNum = 126;BA.debugLine="If K = 1 Then Activity.AddView(IV, LL-(Lbl3.Width-WW), TT, Lbl3.Width, Lbl3.Width)";
if (_k==1) { 
mostCurrent._activity.AddView((android.view.View)(_iv.getObject()),(int) (_ll-(mostCurrent._lbl3.getWidth()-_ww)),_tt,mostCurrent._lbl3.getWidth(),mostCurrent._lbl3.getWidth());};
 //BA.debugLineNum = 127;BA.debugLine="If K = 2 Then Activity.AddView(IV, LL, TT-(Lbl3.Width-HH), Lbl3.Width, Lbl3.Width)";
if (_k==2) { 
mostCurrent._activity.AddView((android.view.View)(_iv.getObject()),_ll,(int) (_tt-(mostCurrent._lbl3.getWidth()-_hh)),mostCurrent._lbl3.getWidth(),mostCurrent._lbl3.getWidth());};
 //BA.debugLineNum = 128;BA.debugLine="If K = 3 Then Activity.AddView(IV, LL, TT-(Lbl3.Width-HH), Lbl3.Width, Lbl3.Width)";
if (_k==3) { 
mostCurrent._activity.AddView((android.view.View)(_iv.getObject()),_ll,(int) (_tt-(mostCurrent._lbl3.getWidth()-_hh)),mostCurrent._lbl3.getWidth(),mostCurrent._lbl3.getWidth());};
 //BA.debugLineNum = 130;BA.debugLine="Dim LB As Label";
_lb = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 131;BA.debugLine="LB.Initialize(\"Label\")";
_lb.Initialize(mostCurrent.activityBA,"Label");
 //BA.debugLineNum = 132;BA.debugLine="LB.BringToFront";
_lb.BringToFront();
 //BA.debugLineNum = 133;BA.debugLine="LB.Visible = True";
_lb.setVisible(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 134;BA.debugLine="LB.Color = Colors.White";
_lb.setColor(anywheresoftware.b4a.keywords.Common.Colors.White);
 //BA.debugLineNum = 135;BA.debugLine="LB.TextColor = Colors.Black";
_lb.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 //BA.debugLineNum = 136;BA.debugLine="If Activity.Height > Activity.Width Then";
if (mostCurrent._activity.getHeight()>mostCurrent._activity.getWidth()) { 
 //BA.debugLineNum = 137;BA.debugLine="If K = 0 Then Activity.AddView(LB, LL+Lbl3.Height, TT+(5*Lbl3.Height), 12*Lbl3.Height-4dip, 6*Lbl3.Height)";
if (_k==0) { 
mostCurrent._activity.AddView((android.view.View)(_lb.getObject()),(int) (_ll+mostCurrent._lbl3.getHeight()),(int) (_tt+(5*mostCurrent._lbl3.getHeight())),(int) (12*mostCurrent._lbl3.getHeight()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (4))),(int) (6*mostCurrent._lbl3.getHeight()));};
 //BA.debugLineNum = 138;BA.debugLine="If K = 1 Then Activity.AddView(LB, LL+Lbl3.Height+(WW-Lbl3.Width), TT+(5*Lbl3.Height), 12*Lbl3.Height-4dip, 6*Lbl3.Height)";
if (_k==1) { 
mostCurrent._activity.AddView((android.view.View)(_lb.getObject()),(int) (_ll+mostCurrent._lbl3.getHeight()+(_ww-mostCurrent._lbl3.getWidth())),(int) (_tt+(5*mostCurrent._lbl3.getHeight())),(int) (12*mostCurrent._lbl3.getHeight()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (4))),(int) (6*mostCurrent._lbl3.getHeight()));};
 //BA.debugLineNum = 139;BA.debugLine="If K = 2 Then Activity.AddView(LB, LL+Lbl3.Height, TT-(Lbl3.Width-HH)+3*Lbl3.Height+4dip, 12*Lbl3.Height-4dip, 6*Lbl3.Height)";
if (_k==2) { 
mostCurrent._activity.AddView((android.view.View)(_lb.getObject()),(int) (_ll+mostCurrent._lbl3.getHeight()),(int) (_tt-(mostCurrent._lbl3.getWidth()-_hh)+3*mostCurrent._lbl3.getHeight()+anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (4))),(int) (12*mostCurrent._lbl3.getHeight()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (4))),(int) (6*mostCurrent._lbl3.getHeight()));};
 //BA.debugLineNum = 140;BA.debugLine="If K = 3 Then Activity.AddView(LB, LL+Lbl3.Height, TT-(Lbl3.Width-HH)+3*Lbl3.Height+5dip, 12*Lbl3.Height-4dip, 6*Lbl3.Height)";
if (_k==3) { 
mostCurrent._activity.AddView((android.view.View)(_lb.getObject()),(int) (_ll+mostCurrent._lbl3.getHeight()),(int) (_tt-(mostCurrent._lbl3.getWidth()-_hh)+3*mostCurrent._lbl3.getHeight()+anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (5))),(int) (12*mostCurrent._lbl3.getHeight()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (4))),(int) (6*mostCurrent._lbl3.getHeight()));};
 }else {
 //BA.debugLineNum = 142;BA.debugLine="If K = 0 Then Activity.AddView(LB, LL+(Lbl3.Height), TT+(5*Lbl3.Height), 11*Lbl3.Height, 6*Lbl3.Height)";
if (_k==0) { 
mostCurrent._activity.AddView((android.view.View)(_lb.getObject()),(int) (_ll+(mostCurrent._lbl3.getHeight())),(int) (_tt+(5*mostCurrent._lbl3.getHeight())),(int) (11*mostCurrent._lbl3.getHeight()),(int) (6*mostCurrent._lbl3.getHeight()));};
 //BA.debugLineNum = 143;BA.debugLine="If K = 1 Then Activity.AddView(LB, LL+(Lbl3.Height)+(WW-Lbl3.Width), TT+(5*Lbl3.Height), 11*Lbl3.Height, 6*Lbl3.Height)";
if (_k==1) { 
mostCurrent._activity.AddView((android.view.View)(_lb.getObject()),(int) (_ll+(mostCurrent._lbl3.getHeight())+(_ww-mostCurrent._lbl3.getWidth())),(int) (_tt+(5*mostCurrent._lbl3.getHeight())),(int) (11*mostCurrent._lbl3.getHeight()),(int) (6*mostCurrent._lbl3.getHeight()));};
 //BA.debugLineNum = 144;BA.debugLine="If K = 2 Then Activity.AddView(LB, LL+(Lbl3.Height), TT-(Lbl3.Width-HH)+3*Lbl3.Height, 11*Lbl3.Height, 6*Lbl3.Height)";
if (_k==2) { 
mostCurrent._activity.AddView((android.view.View)(_lb.getObject()),(int) (_ll+(mostCurrent._lbl3.getHeight())),(int) (_tt-(mostCurrent._lbl3.getWidth()-_hh)+3*mostCurrent._lbl3.getHeight()),(int) (11*mostCurrent._lbl3.getHeight()),(int) (6*mostCurrent._lbl3.getHeight()));};
 //BA.debugLineNum = 145;BA.debugLine="If K = 3 Then Activity.AddView(LB, LL+(Lbl3.Height), TT-(Lbl3.Width-HH)+3*Lbl3.Height, 11*Lbl3.Height, 6*Lbl3.Height)";
if (_k==3) { 
mostCurrent._activity.AddView((android.view.View)(_lb.getObject()),(int) (_ll+(mostCurrent._lbl3.getHeight())),(int) (_tt-(mostCurrent._lbl3.getWidth()-_hh)+3*mostCurrent._lbl3.getHeight()),(int) (11*mostCurrent._lbl3.getHeight()),(int) (6*mostCurrent._lbl3.getHeight()));};
 };
 //BA.debugLineNum = 147;BA.debugLine="LB.TextSize = Lbl3.TextSize";
_lb.setTextSize(mostCurrent._lbl3.getTextSize());
 //BA.debugLineNum = 148;BA.debugLine="LB.Text = TXT";
_lb.setText((Object)(mostCurrent._txt));
 //BA.debugLineNum = 149;BA.debugLine="qq = Activity.NumberOfViews : LN = qq-1";
_qq = mostCurrent._activity.getNumberOfViews();
 //BA.debugLineNum = 149;BA.debugLine="qq = Activity.NumberOfViews : LN = qq-1";
_ln = (int) (_qq-1);
 //BA.debugLineNum = 150;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 21;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 25;BA.debugLine="Private Button1 As Button";
mostCurrent._button1 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 26;BA.debugLine="Private Button2 As Button";
mostCurrent._button2 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 27;BA.debugLine="Private Button3 As Button";
mostCurrent._button3 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 28;BA.debugLine="Private Button4 As Button";
mostCurrent._button4 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 29;BA.debugLine="Private EditText1 As EditText";
mostCurrent._edittext1 = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 30;BA.debugLine="Private Label4 As Label";
mostCurrent._label4 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 31;BA.debugLine="Private ListView1 As ListView";
mostCurrent._listview1 = new anywheresoftware.b4a.objects.ListViewWrapper();
 //BA.debugLineNum = 32;BA.debugLine="Private Lbl3 As Label";
mostCurrent._lbl3 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 33;BA.debugLine="Private Panel1 As Panel";
mostCurrent._panel1 = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 36;BA.debugLine="Dim D, K, NoViews As Int";
_d = 0;
_k = 0;
_noviews = 0;
 //BA.debugLineNum = 37;BA.debugLine="Dim LN, BV, qq As Int";
_ln = 0;
_bv = 0;
_qq = 0;
 //BA.debugLineNum = 38;BA.debugLine="Dim Pictures(4) As String Array";
mostCurrent._pictures = new String[(int) (4)];
java.util.Arrays.fill(mostCurrent._pictures,"");
 //BA.debugLineNum = 39;BA.debugLine="Dim Dmn As String";
mostCurrent._dmn = "";
 //BA.debugLineNum = 40;BA.debugLine="Dim ArcPos(7)";
mostCurrent._arcpos = new String[(int) (7)];
java.util.Arrays.fill(mostCurrent._arcpos,"");
 //BA.debugLineNum = 41;BA.debugLine="Dim LL, TT, WW, HH As Int";
_ll = 0;
_tt = 0;
_ww = 0;
_hh = 0;
 //BA.debugLineNum = 42;BA.debugLine="Dim TXT, PosObj, NPos As String";
mostCurrent._txt = "";
mostCurrent._posobj = "";
mostCurrent._npos = "";
 //BA.debugLineNum = 43;BA.debugLine="Dim Sx, Sy, Tx As Int";
_sx = 0;
_sy = 0;
_tx = 0;
 //BA.debugLineNum = 44;BA.debugLine="Dim Valore, Coord, Ncoord As String";
mostCurrent._valore = "";
mostCurrent._coord = "";
mostCurrent._ncoord = "";
 //BA.debugLineNum = 45;BA.debugLine="Dim T(7)";
mostCurrent._t = new String[(int) (7)];
java.util.Arrays.fill(mostCurrent._t,"");
 //BA.debugLineNum = 46;BA.debugLine="Dim V(7)";
mostCurrent._v = new String[(int) (7)];
java.util.Arrays.fill(mostCurrent._v,"");
 //BA.debugLineNum = 47;BA.debugLine="Dim Pos(7)";
mostCurrent._pos = new String[(int) (7)];
java.util.Arrays.fill(mostCurrent._pos,"");
 //BA.debugLineNum = 48;BA.debugLine="Dim Name, Linea, Linew, Coor As String";
mostCurrent._name = "";
mostCurrent._linea = "";
mostCurrent._linew = "";
mostCurrent._coor = "";
 //BA.debugLineNum = 49;BA.debugLine="Dim A, B, C, D As Int";
_a = 0;
_b = 0;
_c = 0;
_d = 0;
 //BA.debugLineNum = 50;BA.debugLine="Dim nx, ny As Int";
_nx = 0;
_ny = 0;
 //BA.debugLineNum = 52;BA.debugLine="End Sub";
return "";
}
public static String  _idobj() throws Exception{
int _i = 0;
int _n = 0;
 //BA.debugLineNum = 190;BA.debugLine="Sub IdObj";
 //BA.debugLineNum = 191;BA.debugLine="For i = 0 To 6";
{
final int step151 = 1;
final int limit151 = (int) (6);
for (_i = (int) (0); (step151 > 0 && _i <= limit151) || (step151 < 0 && _i >= limit151); _i = ((int)(0 + _i + step151))) {
 //BA.debugLineNum = 192;BA.debugLine="PosObj = ArcPos(i)";
mostCurrent._posobj = mostCurrent._arcpos[_i];
 //BA.debugLineNum = 193;BA.debugLine="For n = 0 To 3";
{
final int step153 = 1;
final int limit153 = (int) (3);
for (_n = (int) (0); (step153 > 0 && _n <= limit153) || (step153 < 0 && _n >= limit153); _n = ((int)(0 + _n + step153))) {
 //BA.debugLineNum = 194;BA.debugLine="Tx = (PosObj).IndexOf(\",\")";
_tx = (mostCurrent._posobj).indexOf(",");
 //BA.debugLineNum = 195;BA.debugLine="Dmn = PosObj.SubString2(0, Tx)";
mostCurrent._dmn = mostCurrent._posobj.substring((int) (0),_tx);
 //BA.debugLineNum = 196;BA.debugLine="If n = 0 Then LL = Dmn";
if (_n==0) { 
_ll = (int)(Double.parseDouble(mostCurrent._dmn));};
 //BA.debugLineNum = 197;BA.debugLine="If n = 1 Then TT = Dmn";
if (_n==1) { 
_tt = (int)(Double.parseDouble(mostCurrent._dmn));};
 //BA.debugLineNum = 198;BA.debugLine="If n = 2 Then WW = Dmn";
if (_n==2) { 
_ww = (int)(Double.parseDouble(mostCurrent._dmn));};
 //BA.debugLineNum = 199;BA.debugLine="If n = 3 Then HH = Dmn";
if (_n==3) { 
_hh = (int)(Double.parseDouble(mostCurrent._dmn));};
 //BA.debugLineNum = 201;BA.debugLine="NPos = PosObj.SubString2(Tx+1, PosObj.Length)";
mostCurrent._npos = mostCurrent._posobj.substring((int) (_tx+1),mostCurrent._posobj.length());
 //BA.debugLineNum = 202;BA.debugLine="PosObj = NPos";
mostCurrent._posobj = mostCurrent._npos;
 }
};
 //BA.debugLineNum = 204;BA.debugLine="If (Sx > LL AND Sx < LL+WW) AND (Sy > TT AND Sy < TT+HH) Then";
if ((_sx>_ll && _sx<_ll+_ww) && (_sy>_tt && _sy<_tt+_hh)) { 
 //BA.debugLineNum = 205;BA.debugLine="TXT = PosObj";
mostCurrent._txt = mostCurrent._posobj;
 //BA.debugLineNum = 206;BA.debugLine="SetPos";
_setpos();
 };
 }
};
 //BA.debugLineNum = 209;BA.debugLine="End Sub";
return "";
}
public static String  _imageview_click() throws Exception{
anywheresoftware.b4a.objects.ImageViewWrapper _iv = null;
 //BA.debugLineNum = 160;BA.debugLine="Sub ImageView_click";
 //BA.debugLineNum = 161;BA.debugLine="Dim IV As ImageView";
_iv = new anywheresoftware.b4a.objects.ImageViewWrapper();
 //BA.debugLineNum = 162;BA.debugLine="IV.Initialize(\"ImageView\")";
_iv.Initialize(mostCurrent.activityBA,"ImageView");
 //BA.debugLineNum = 163;BA.debugLine="IV = Sender";
_iv.setObject((android.widget.ImageView)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 164;BA.debugLine="ClearList";
_clearlist();
 //BA.debugLineNum = 165;BA.debugLine="End Sub";
return "";
}
public static String  _label_click() throws Exception{
anywheresoftware.b4a.objects.LabelWrapper _lb = null;
 //BA.debugLineNum = 167;BA.debugLine="Sub Label_Click";
 //BA.debugLineNum = 168;BA.debugLine="Dim LB As Label";
_lb = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 169;BA.debugLine="LB.Initialize(\"Label\")";
_lb.Initialize(mostCurrent.activityBA,"Label");
 //BA.debugLineNum = 170;BA.debugLine="LB = Sender";
_lb.setObject((android.widget.TextView)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 171;BA.debugLine="ClearList";
_clearlist();
 //BA.debugLineNum = 172;BA.debugLine="End Sub";
return "";
}
public static String  _lbl3_longclick() throws Exception{
 //BA.debugLineNum = 211;BA.debugLine="Sub Lbl3_LongClick";
 //BA.debugLineNum = 212;BA.debugLine="If Panel1.Enabled = True Then";
if (mostCurrent._panel1.getEnabled()==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 213;BA.debugLine="Panel1.Enabled = False";
mostCurrent._panel1.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 }else {
 //BA.debugLineNum = 215;BA.debugLine="Panel1.Enabled = True";
mostCurrent._panel1.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 };
 //BA.debugLineNum = 217;BA.debugLine="End Sub";
return "";
}
public static boolean  _panel1_touch(int _action,float _x,float _y) throws Exception{
 //BA.debugLineNum = 182;BA.debugLine="Sub Panel1_Touch (Action As Int, X As Float, Y As Float) As Boolean";
 //BA.debugLineNum = 183;BA.debugLine="If Action = Activity.ACTION_DOWN Then";
if (_action==mostCurrent._activity.ACTION_DOWN) { 
 //BA.debugLineNum = 184;BA.debugLine="Sx = X";
_sx = (int) (_x);
 //BA.debugLineNum = 185;BA.debugLine="Sy = Y";
_sy = (int) (_y);
 //BA.debugLineNum = 186;BA.debugLine="IdObj";
_idobj();
 };
 //BA.debugLineNum = 188;BA.debugLine="End Sub";
return false;
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 19;BA.debugLine="End Sub";
return "";
}
public static String  _setpos() throws Exception{
 //BA.debugLineNum = 152;BA.debugLine="Sub SetPos";
 //BA.debugLineNum = 153;BA.debugLine="If LL < D AND TT < ((2*D)*3)/4 Then K = 0  '349";
if (_ll<_d && _tt<((2*_d)*3)/(double)4) { 
_k = (int) (0);};
 //BA.debugLineNum = 154;BA.debugLine="If LL > D AND TT < ((2*D)*3)/4 Then K = 1";
if (_ll>_d && _tt<((2*_d)*3)/(double)4) { 
_k = (int) (1);};
 //BA.debugLineNum = 155;BA.debugLine="If LL < D AND TT > ((2*D)*3)/4 Then K = 2";
if (_ll<_d && _tt>((2*_d)*3)/(double)4) { 
_k = (int) (2);};
 //BA.debugLineNum = 156;BA.debugLine="If LL > D AND TT > ((2*D)*3)/4 Then K = 3";
if (_ll>_d && _tt>((2*_d)*3)/(double)4) { 
_k = (int) (3);};
 //BA.debugLineNum = 157;BA.debugLine="CreaBal";
_creabal();
 //BA.debugLineNum = 158;BA.debugLine="End Sub";
return "";
}
}
